package com.diagbot.facade;

import com.diagbot.dto.RespDTO;
import com.diagbot.entity.UserRenewals;
import com.diagbot.exception.CommonErrorCode;
import com.diagbot.exception.CommonException;
import com.diagbot.service.impl.UserRenewalsServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.UserUtils;
import com.diagbot.vo.AddRenewalsInfoVO;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description:
 * @author: wangyu
 * @time: 2018/10/12 15:31
 */
@Component
public class UserRenewalsFacade extends UserRenewalsServiceImpl {

    public RespDTO<Boolean> addRenewalsInfos(AddRenewalsInfoVO addRenewalsInfoVO){
        UserRenewals userRenewals =new UserRenewals();
        String user = UserUtils.getCurrentPrincipleID();
        Long userId = Long.parseLong(user);
        userRenewals.setCreator(user);
        userRenewals.setUserId(userId);
        userRenewals.setApplyTime(DateUtil.now());
        userRenewals.setGmtCreate(DateUtil.now());
        List<Long> productId =this.selectProductIdByUserId(userId);
        for(int i =0 ; i < productId.size(); i++){
            if(productId.get(i).longValue() == addRenewalsInfoVO.getProductId().longValue()){
                throw new CommonException(CommonErrorCode.SERVER_IS_ERROR, "请勿重复提交申请");
            }
        }
        userRenewals.setProductId(addRenewalsInfoVO.getProductId());
        return RespDTO.onSuc(this.save(userRenewals));
    }
}
